@echo off
:: VER must be exactly 4 characters
set VER=1.08

pushd "%~dp0"
title ChocBox v%VER%
SETLOCAL EnableDelayedExpansion

:start
color 1f
cls

echo.
echo **********************************************************************
echo *                                                                    *
echo *               CHOCBOX v%VER%  (www.easy2boot.com SSi)               *
echo *                                                                    *
echo *       Packages are listed at https://chocolatey.org/packages       *
echo *                                                                    *
echo *  Find a Chocolatey app and download to C:\DRIVERS\chocbox folder   *
echo *                                                                    *
echo **********************************************************************
echo.
if not "%1"=="am_admin" call powershell -h | %WINDIR%\System32\find.exe /i "powershell" > nul && if not "%1"=="am_admin" (powershell start -verb runas '%0' am_admin > nul & exit)
call :checkperms
if "%ADMIN%"=="FAIL" goto :EOF
echo.
echo INFORMATION: Some type of AntiVirus software can cause chocolatey to run extremely slowly. If very slow, completely disable your AV software or uninstall it.
echo.
cmd /c choco list -h 2> nul | %WINDIR%\System32\find.exe "password" > nul || (if exist "%~dp0\Install_Chocolatey.cmd" echo. & echo Chocolatey not installed^^! Press ENTER to install Chocolatey... & pause && call "%~dp0\Install_Chocolatey.cmd" & pause & goto :start)
cmd /c choco list -h 2> nul | %WINDIR%\System32\find.exe "password" > nul || (echo Chocolatey not installed^^! & pause & goto :EOF)
set app=
echo. & echo. | set /p xx=Chocolatey is version: & choco --version
choco --version | %WINDIR%\System32\find.exe "0.10.5" > nul && (echo. & echo. ***** WARNING: Chocolatey v0.10.5 has bugs when listing packages - please update using 'choco update chocolatey'. ***** & echo.)
choco --version | %WINDIR%\System32\find.exe "0.10.6.0" > nul && (echo. & echo. ***** WARNING: Chocolatey v0.10.6.0 has bugs when listing packages - please update using 'choco update chocolatey'. ***** & echo.)
echo.
echo First we must find the name of the app. package
echo.
set /p app=Enter partial name of application, e.g. foxit (ENTER=quit) : 
if "%app%"=="" goto :EOF
:getapp
cls
echo ChocBox v%VER%
echo Searching list of matching approved apps for "%app%"...
echo **********************************************************************
echo.
choco list %app% --not-broken --order-by-popularity --approved-only | %WINDIR%\System32\find.exe /i "%app%" || (echo NONE FOUND^^! & pause & goto :start)
echo.
echo **********************************************************************

set appx=
echo Tip: Use a .install package if there is one.
echo.
set /p "appx=Enter exact name - CASE SENSITIVE^! ^(R=Restart, Q=Quit, W=Website search for %app%^) : "
if "%appx%"=="" set appx=%app%
if "%appx%"=="" goto :start
if /i "%appx%"=="Q" goto :EOF
if /i "%appx%"=="R" goto :start
if /i "%appx%"=="W" cmd /c "start https://chocolatey.org/packages?q="%app% & goto :getapp

cls
echo ChocBox v%VER%
echo.
echo **********************************************************************
echo Searching for recent versions of %appx% - please wait...
echo.
set i=0
for /F "tokens=*" %%g in ('choco list %appx% --not-broken --approved-only -e -a -by-id-only') do (set /a i=!i!+1 & if !i! LEQ 20 echo %%g | %WINDIR%\System32\find.exe /i "%appx%")
echo.
if !i! LEQ 1  (

echo WARNING: Cannot find exact match - listing all apps, please wait...
echo.
choco list %appx% --not-broken --approved-only | %WINDIR%\System32\find.exe /i "%appx%" || echo. & echo. & color 4f & echo WARNING: Cannot find approved app for %appx% - check case and spelling^^! & echo. & echo We will try anyway... & echo.
)

echo **********************************************************************
echo.
set version=
set /p version=Version number [ ENTER=current version ] : 
if not "%version%"=="" choco list %appx% --version %version%
echo.
echo Downloading and converting %appx% %version% to run from C:\DRIVERS\chocbox
if not exist C:\drivers\nul mkdir C:\DRIVERS
if not exist C:\drivers\chocbox\nul mkdir C:\DRIVERS\CHOCBOX

echo Running ChocolateStore to make package...
if "%version%"=="" ChocolateStore.exe c:\drivers\chocbox https://push.chocolatey.org/api/v2/package/%appx%
if not "%version%"=="" ChocolateStore.exe c:\drivers\chocbox https://push.chocolatey.org/api/v2/package/%appx%/%version%

if not exist "C:\drivers\chocbox\%appx%*.nupkg" (echo. & color 4f & echo **** ERROR: Package not downloaded - is there a '.install' package? && pause && goto :start)
echo.
set CL=
if "%version%"=="" set "CL=choco install %appx% --source C:\DRIVERS\chocbox -y -r  ^>^> %%log%%"
if not "%version%"=="" set "CL=choco install %appx% --version=%version% --source C:\DRIVERS\chocbox -y -r  ^>^> %%log%%"
echo.
echo ======================================== INSTRUCTIONS ==================================================
echo.
echo 1. Copy the C:\DRIVERS\chocbox contents to your E2B USB drive at \_ISO\WINDOWS\INSTALLS\APPS\chocbox\
echo.
echo 2. Make an OfflineChoco.tag file in your \_ISO\WINDOWS\INSTALLS\CONFIGS\XXXXXX folder.
echo    This will cause Choco to be installed from the E2B \_ISO\WINDOWS\INSTALLS\INSTALLCHOCO folder, and
echo    all files and folders in \_ISO\WINDOWS\INSTALLS\APPS\chocbox\ will be copied to the target drive.
echo.
echo 3. Add lines into \_ISO\WINDOWS\INSTALLS\CONFIGS\XXXXXX\MyStartup.cmd file to install each app, e.g.
echo.
echo            %CL%
echo.
echo =========================================================================================================
echo.
set dot=
if not "%version%"=="" set dot=.
echo Saving code line to C:\DRIVERS\CHOCBOX\%appx%%dot%%version%.txt
echo %CL% > C:\DRIVERS\CHOCBOX\%appx%%dot%%version%.txt
echo.

pause
goto :start



:checkperms
set randname=%random%%random%%random%%random%%random%
md "%windir%\%randname%" 2>nul
if %errorlevel%==0 (echo Administrative permissions confirmed.
goto end)
if %errorlevel%==1 (
    echo Sorry - you need to run as Administrator [use right-click - Run as administrator].
	echo.
	color cf
	pause
	Set ADMIN=FAIL
	goto end)
goto checkperms
:end
rd "%windir%\%randname%" 2>nul
goto :eof

